"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var metalsmith_1 = __importDefault(require("metalsmith"));
var chalk_1 = __importDefault(require("chalk"));
var consolidate_1 = __importDefault(require("consolidate"));
var async_1 = __importDefault(require("async"));
var path_1 = __importDefault(require("path"));
var fs_extra_1 = __importDefault(require("fs-extra"));
var git_user_1 = __importDefault(require("./git-user"));
var utils_1 = require("../utils/utils");
var ask_1 = __importDefault(require("./ask"));
exports.default = (function (renderObj, macros) { return __awaiter(void 0, void 0, void 0, function () {
    var templatePath, destPath, description, projectDirectory, newProjectDirectory, newDestPath, isExists;
    return __generator(this, function (_a) {
        templatePath = renderObj.templatePath, destPath = renderObj.destPath, description = renderObj.description, projectDirectory = renderObj.projectDirectory;
        newProjectDirectory = projectDirectory;
        newDestPath = destPath;
        isExists = fs_extra_1.default.pathExistsSync(destPath);
        if (isExists) {
            console.log(chalk_1.default.red('此项目已存在，请变更名字后重试'));
            return [2 /*return*/];
        }
        metalsmith_1.default(process.cwd())
            .metadata({
            name: newProjectDirectory,
            description: description,
        })
            .source(templatePath)
            .destination(newDestPath)
            .clean(false)
            .use(askQuestions({
            name: { default: newProjectDirectory, type: 'string' },
            author: { default: git_user_1.default(), type: 'string' },
            description: { default: description, type: 'string' },
            platform: {
                default: macros.defaultPlatform,
                type: 'list',
                choices: macros.choices
            }
        }))
            .use(filterPlatform(macros))
            .use(renderTemplateFiles())
            .use(removeFile())
            .build(function (err) {
            if (!err) {
                console.log(chalk_1.default.green('create project success!'));
            }
        });
        return [2 /*return*/];
    });
}); });
var filterPlatform = function (macros) {
    return function (_, metalsmith, done) {
        var platform = metalsmith._metadata.platform;
        metalsmith._metadata.platformTitle = utils_1.firstUpperCase(platform);
        macros.choices.forEach(function (item) {
            metalsmith._metadata[item.value] = item.value === platform ? true : false;
        });
        done();
    };
};
var removeFile = function () {
    return function (files, metalsmith, done) {
        var platform = metalsmith._metadata.platform;
        if (platform === 'wechat') {
            Object.keys(files).forEach(function (file) {
                if (file === 'mini.project.json') {
                    delete files[file];
                }
            });
        }
        else if (platform === 'toutiao') {
            Object.keys(files).forEach(function (file) {
                if (file === 'mini.project.json' || file === 'project.config.json') {
                    delete files[file];
                }
            });
        }
        else if (platform === 'ali') {
            Object.keys(files).forEach(function (file) {
                if (file === 'project.config.json') {
                    delete files[file];
                }
            });
        }
        done();
    };
};
var askQuestions = function (prompts) {
    return function (_, metalsmith, done) {
        ask_1.default(prompts, metalsmith.metadata(), done);
    };
};
var renderTemplateFiles = function () {
    return function (files, metalsmith, done) {
        var keys = Object.keys(files);
        var metalsmithMetadata = metalsmith.metadata();
        async_1.default.each(keys, function (file, next) {
            var str = files[file].contents.toString();
            if (!/{{([^{}]+)}}/g.test(str)) {
                return next();
            }
            consolidate_1.default.handlebars.render(str, metalsmithMetadata, function (err, res) {
                if (err) {
                    err.message = "[" + file + "] " + err.message;
                    return next(err);
                }
                files[file].contents = Buffer.from(res, 'utf-8');
                next();
            });
        }, done);
    };
};
exports.pathAndRepoUrlGenerator = function (argv, macros) {
    var projectDirectory = argv.projectDirectory, t = argv.t;
    var destPath = path_1.default.join(process.cwd(), projectDirectory);
    var tmpPath = path_1.default.join(__dirname, '../..', macros.tmpPathName);
    var templateRepo = macros.templateRepo;
    var description = macros.description;
    if (t) {
        templateRepo = macros.templateTSRepo;
        description = macros.descriptionTS;
        tmpPath = path_1.default.join(tmpPath, 'ts');
    }
    else {
        tmpPath = path_1.default.join(tmpPath, 'js');
    }
    var templatePath = path_1.default.join(tmpPath, macros.templatePathName);
    return {
        templatePath: templatePath,
        tmpPath: tmpPath,
        destPath: destPath,
        templateRepo: templateRepo,
        description: description,
        projectDirectory: projectDirectory
    };
};
